#include <YoggieEngine.h>
#include "Camera.h"
namespace YoggieEngine {
	Camera::Camera(const Camera& other) 
		: Position(other.Position), Rotation(other.Rotation), Zoom(other.Zoom)
	{
		
	}
	Camera::Camera(glm::vec3 position, glm::vec3 rotation, float zoom) 
		: Position(position), Rotation( rotation)
	{

		Front = glm::vec3(-1.0f, 0.0f, 0.0f);
		Right = glm::vec3(0.0f, 0.0f, 1.0f);
		Up = glm::vec3(0.0f, 1.0f, 0.0f);
		Zoom = zoom;


		ViewMatrix = glm::lookAt(
			Position,
			Position + Front,
			Up);

		ProjectionMatrix = glm::perspective(glm::radians(Zoom), (800.0f / 600.0f), 0.001f, 100.0f);
	
	}

	Camera::~Camera() {

	}

	void Camera::Update() {
		ViewMatrix = glm::lookAt(Position,Position   + Front,Up);
	}

}
