#pragma once
#include "Entity.h"
namespace YoggieEngine {
	struct IdentifierComponent {
		std::string name;
	};


	struct TransformComponent {
		glm::vec3 Position = glm::vec3(0.0f);
		glm::vec3 Rotation = glm::vec3(0.0f);
		glm::vec3 Scale = glm::vec3(1.0f);
		
		glm::mat4 LocalTransform = glm::mat4(1.0f);

	};

	struct RelationComponent {
		Entity Parent;

		RelationComponent(Entity& entity) 
		{
			Parent = entity;
		}

	};


	struct LightComponent {
		glm::vec3 Color = glm::vec3(1.0f, .5f, .5f);
	};


	struct CameraComponent {
		glm::vec3 Position = glm::vec3(0);
		glm::vec3 Rotation = glm::vec3(0);
		float Zoom ;
	};


	struct ScriptComponent {
		std::string file; // TODO : replace with proper properties
	};

	struct Render3DComponent {
		unsigned int VAO = 0;
		unsigned int IBO = 0;
		Mesh mesh;
		// TODO: becomes a material 
		glm::vec3 color;
		Shader shader;

		Render3DComponent()
			: shader(Shader("build/Debug/Shaders/forward/geometry.vert", "build/Debug/Shaders/forward/geometry.frag")),
			  color(glm::vec3(1.0f, 0.0f, 0.0f))
		{ 
		}
	};

	struct Render2DComponent {
		glm::vec3 Colour;
		
	};
};